/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     coded in ECMAScript 5 - JavaScript 5  (ES5, ECMAScript 2009)
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */

//  xxxxxxxxxxxxxxx     wm9 variable declarations  xxxxxxxxxxxxxx


// These variables below can be directly modified by the user on the options form: 

var parad = "0"      // Paradigm type ("0" or "1") 

var rotate = "0";    // rotate shapes ( "1" => do circle parts rotation; "0" => don't rotate circle parts)

var item_cnt = 5;    // total item (tasks) count  

var chv = 5;   // responsive choice number (responsive choices react on click)
  
var is_cor= true;     //  if (true) => One of the options offered will always be correct

var is_back = true;    // if (is_back==true) => user can go back to previous item (Undo) 

var is_forward= true;  // if (is_forward==true) => user can escape (skip) items. Next item button vill be visible. 

var is_border= false;  // if (is_border==true) => draw border around fixed (chf) options 0..8 (big image 3x3) 

var demo = true;       // if (demo == true) => show correct solution

var timer = 600;      // task time in seconds. default==10 min. 

var timer_enabled = false;   // if true =>Task time is limited. This is only for user.  In reality, the timer is always on (must be)
 
var prg_type = "0";   //  type of information in Progress Bar => default: Items (Items/total) 

var store = false;      // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser.

// internal wm9 variables and constants are bellow:

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var is_task = false;    // task in progress or not  (for timer)

var startTime;       // for wm9Timer()
   
var item = 0;   // current item      

var cor = [];   // correct answer for each item

var ans = [];  //  user (client) answer for each item 

var w2;    // 1/2 of choice width = 1/2 of choice height (all choices have same width==height)

var r;      // shape radius => 1/2 of w2  == 1/4*option width ==1/4*option height
 
var dirty = false;  // if  (dirty==true) => user changed any options in form 
      
var stim_b = [];        // canvas (viewport) choices (options) bounds => stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom 

/*  stim = jagged array= for each item [item][option][shape] is separate array:
[ 0.index=  shape number, 1.index = operation, 2.index..N index = operation variable (depends of shape type) ]  */
var stim = [];  

var esc = [];     // escape shape pattern/sequance

// pure const are bellow. const is not used because this source is coded in ECMAScript 5 - JavaScript 5  (ES5, ECMAScript 2009)
// don't ever change this change this constants without changing dependent functions.

var chf = 9;       // non-responsive choices number (non-responsive choices don't react on click)

var clock = 1000;  // basic timer resolution in ms. Default = 1s (1000ms)

// default shape parts colors. this is mostly default set of 16 html Basic colors.
var clr = [    
  '#000000',     /* "black" */   
  '#FF0000',     /* "red"   */
  '#008000',     /* "green" */
  '#0000FF',     /* "blue" */   
  '#FFFF00',     /* "yellow" */     
  '#00FF00',     /* "lime" */     
  '#00FFFF',     /* "cyan" / "aqua" */     
  '#FF00FF',     /* magenta / fuchsia  */  
  '#C0C0C0',     /* "silver" */      
  '#800000',     /* maroon */     
  '#808000',     /* "olive" */  
  '#800080',     /* "purple" */    
  '#008080',     /* teal */      
  '#000080',     /* navy */    
  '#FFC0CB',     /* "pink" */           
  '#8A2BE2',     /* blue violet */ 
  '#FFA500'      /* "orange" */ 
  ];    

 var patt= 
 [  // 0..15 last substring are not used (index 15)
    '1111000000000000' ,   // 1,2,3,4 => choice 0 (chf)
    '0000111100000000' ,   // 5,6,7,8 => choice 1 (chf)
    '1111111100000000' ,   // 1..8  => choice 2    
    '0000000011110000' ,   // 9..12  => choice 3
    '0000000000001110' ,   // 13..15 => choice 4  (only 3 shapes)
    '0000000011111110' ,   // 9..15 => choice 5     
    '1111000011110000' ,   // 1..4 + 9..12 => choice 6
    '0000111100001110' ,   // 5..8 + 13..15 => choice 7
    '1111111111111110'     // 1..15 => choice 8 
  ]; 
  
 var patt2= 
 [   // 0..15 last substring are not used (index 15) 
    '1100000000000000' ,   // 1,2 => choice 0  (chf)
    '0011000000000000' ,   // 3,4 => choice 1  (chf)
    '0000110000000000' ,   // 5,6 => choice 2    
    '0000001100000000' ,   // 7,8 => choice 3
    '0000000011000000' ,   // 9,10 => choice 4
    '0000000000110000' ,   // 11,12 => choice 5         
    '0000000000001000' ,   // 13 => choice 6 (only one shape)
    '0000000000000100' ,   // 14 => choice 7 (only one shape)
    '0000000000000010'     // 15 => choice 8 (only one shape)
  ];  


var smax= patt[0].length-2;      // 14 => (maximum shape number - 1) => pseudorandom parts of circle. range: 0..14

             
/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
                          wm9 functions
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */


// create/start Timer, [center panels], and show start panel.. 
function init() 
{   
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {wm9Timer()},clock);     
  showStart(); 
  if (isStorage() && storageAvailable('localStorage'))  {
    document.getElementById("store_group").disabled= false;
  }
  else 
  {
    document.getElementById("store_msg").textContent= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline).";
    document.getElementById("store_group").disabled= true;  
    document.getElementById("clr_store").disabled= true;     // IE11 bug  => childrens are not auto disabled
    document.getElementById("store").disabled= true;          // IE11 bug => childrens are not auto disabled
  }       
}   
 

// show start panel 
function showStart()  
{      
  document.getElementById("end").style.display= "none";
  document.getElementById("google-wrapper").style.display="none";  
  document.getElementById("start").style.display= "block";
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  {
  if (typeof(Storage) !== "undefined") {
     return true;               // Code for localStorage/sessionStorage.     
  } 
  else {
    return false;           // code for no browser Web Storage support
  }  
}


// necessarily because of IE11 and Edge offline mode
function storageAvailable(type) {
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// show forms with application options
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{
  document.getElementById("hide_option").style.display ="block";
  document.getElementById("options").style.display= "block";
  document.getElementById("start").classList.remove("child");  // don't work in <= IE 9    
  document.getElementById("start_div").style.display="none";  // .disabled = true;   
  document.getElementById("show_option").style.display ="none";  
  document.getElementById("hide_option").style="text-align:center";  // bug? auto-remove style when element.style.display="none"
  document.getElementById("instructions").style.display ="none";     
  if ( document.getElementById("store_group").disabled === false && localStorage.getItem("wm9-v1.0")) 
  {
    var cnt= JSON.parse(localStorage.getItem("wm9-v1.0")).length;                                                        
    document.getElementById("store_cnt").textContent=  "You have a total of " + cnt  + " wm9 results stored in your web browser";
  }
  dirty= false;
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{
  setVarPar();   
  document.getElementById("options").style.display="none"; 
  document.getElementById("start").classList.add("child");   
  document.getElementById("show_option").style.display ="block";   
  document.getElementById("start_div").style.display="block";       
  document.getElementById("hide_option").style.display ="none";   
  document.getElementById("start_div").style="text-align:center";  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById("show_option").style="text-align:center";   // bug?  
  document.getElementById("instructions").style.display ="block";   
  // update instructions
  document.getElementById("ins_forward").style.display = is_forward ? "block" : "none";
  document.getElementById("ins_back").style.display = is_back ? "block" : "none"; 
  document.getElementById("ins_demo").style.display = demo ? "block" : "none";
  document.getElementById("ins_timer").style.display = (document.getElementById("timer_enabled").checked) ? "block" : "none";   
  if (parad === "0") {       
   document.getElementById("ins_parad0").style.display= "block"; 
   document.getElementById("ins_parad1").style.display= "none";              
  }
  else   { 
   document.getElementById("ins_parad1").style.display= "block";
   document.getElementById("ins_parad0").style.display= "none";                  
  }
  document.getElementById("ins_rotate").style.display= (rotate === "1") ? "block" : "none";
 
  refMsg();  
}

       
// refresh variable research Options (update *_msg label) => give user short option help
function refOption(e)  
{   
  dirty=true;       
  var my_id = e.id, msg = document.getElementById(my_id + "_msg"), s = "Values within this range are allowed: ", s2= " with step= ";    
  
  switch (my_id)
  {   
  
    case "parad":                                                                                                        
      msg.textContent= (e.value === "0") ? "All drawings within each row and column follow a hidden rule"  
                                           : "Inside the large drawing is missing 1 part to fill the entire circle";                
      break;     
    
    case "rotate":                                                                                                                                             
      msg.textContent= (e.value === "1") ? "Circle parts are rotated" : "Circle parts are not rotated";                     
      break;    
    
    case "item_cnt":        
      if (e.validity.valid)  {           
        msg.removeAttribute("class");       
        msg.textContent= "";       //msg.textContent=  e.value;      
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");    // msg.className = 'error';
      }    
      break;
      
    case "chv":    
      if (e.validity.valid)  {           
        msg.removeAttribute("class");
        msg.textContent= "";                
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");  
      }  
      break;         
            
    case "is_cor":                                                                                                                                                
      if (e.value === "0") {
        msg.textContent= "There may not be an exact solution in some tasks";        //None of the drawings must always be accurate
        document.getElementById("is_forward").checked = true; 
        document.getElementById("is_forward").disabled = true; 
        document.getElementById("is_forward_msg").textContent= "Yes";      
      }
      else {                     
        msg.textContent= "One of the options offered will always be correct";
        document.getElementById("is_forward").disabled = false;
      }   
      break;   
             
    case "is_back": 
    case "is_forward":
    case "is_border":   
      msg.textContent= (e.checked) ?  "Yes" : "No";         
      break;        
                  
    case "demo":  
      if (e.checked) {
        msg.textContent= " (Yes -The correct answer will have a background in this color)";
        msg.setAttribute("style", "background-color:#FFFFF0");   // ivory
      }
      else  {
        msg.textContent=" (No)";
        msg.removeAttribute("style");
      }    
      break;
      
    case "timer":  
      if (e.validity.valid) {    
        msg.removeAttribute("class");
        msg.textContent= stringTime(e.value);       
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");
      } 
      break; 
 
    case "timer_enabled":  
      if (e.checked) {
        msg.textContent= "Yes";
        document.getElementById("timer").disabled = false;             
        //document.getElementById("prg_type").value= "1";
      }
      else  {  
        msg.textContent= "Timer is disabled";
        document.getElementById("timer").disabled =true;        
        //document.getElementById("prg_type").value= "0";      
      }       
      break;
       
    case "prg_type":                                                                                                                                            
      msg.textContent= (e.value === "0") ? "It will be displayed how many tasks are left to the end" : "The remaining time until the end of the task will be displayed (only if timer is enabled)";
      break; 
                                
    case "store":                                                                                                                                            
      msg.textContent= (e.value === "1") ? "This web application will store the results inside your web browser (no expiration date). Useful for group research" : "This web application will not store results within your web browser. Data is lost when the browser tab is closed";
      // break;          
    
  }   // switch (my_id)
  
  refMsg();   
}


// refresh main validator message for user defined OPTIONS (feedback to user)
function refMsg()   
{ 
 if ( optionsValid() )   {
    document.getElementById("is_valid").textContent=  (dirty===true) ? "All your settings have been successfully updated" : "";  
    document.getElementById("is_valid").style="text-align:center;color:#000000"; 
  }
  else  {
    document.getElementById("is_valid").textContent="Some of your options are incorrectly set. They were not updated. These settings are marked in red."; 
    document.getElementById("is_valid").style= "text-align:center;color:#ff0000;font-weight:bold"; // safari 5.1.7 bug? => this don't work
  } 
}


// check for validity.valid object in all input type="number" 
function optionsValid()  
{     
  var res=  document.getElementById("item_cnt").validity.valid &&    
  document.getElementById("chv").validity.valid  &&
  document.getElementById("timer").validity.valid;
  return res;       // Firefox parser don't execute code ok without res var           
}


// start wm9 Task (start research) 
function startTask(e)   
{     
  e.disabled= true;
  stimGenerator(); 
  e.disabled= false;   
  do  
   var ok= e.disabled;
  while (ok); // timer will wait for stimulus generator for large item_cnt 
  document.getElementById("google-wrapper").style.display="none";
  document.getElementById("end").style.display= "none"; 
  document.getElementById("start").style.display= "none"; 
  document.getElementById("canvas").style.display="block";            
    
  timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
  document.getElementById("progress").style.display= "block";     
  document.getElementById("progress").setAttribute("style", "width:100%");   
  document.getElementById("time_left").textContent= "";
  if  (document.getElementById("prg_type").value === "1")  {
     document.getElementById("progress").className= "progress-bar progress-bar-danger progress-bar-striped";  // remaining time   
  }
  else  {
     document.getElementById("progress").className="progress-bar progress-bar-info progress-bar-striped";     // items/total
  } 
  document.getElementById("progress").setAttribute("style", "width:0");  // reset progress bar width
  
  startTime= Date.now();  // returns a number representing the milliseconds elapsed since the UNIX epoch. The Date.now() method returns the number of milliseconds elapsed since January 1, 1970 00:00:00 UTC.    
  is_task= true;  // finally "activate" timer
  
  item=0;
  drawStim();     // draw first stimulus     
}


// set application variable parameters
function setVarPar()  
{  
  parad= document.getElementById("parad").value;   // Paradigm type ("0" or "1") 
  
  rotate= document.getElementById("rotate").value;  // do shape rotation ("1") on don't use shape rotation ("0")
  
  if (document.getElementById("item_cnt").validity.valid) item_cnt= parseInt(document.getElementById("item_cnt").value, 10);  // item count      
  
  if (document.getElementById("chv").validity.valid)  chv = parseInt(document.getElementById("chv").value, 10);     // variable options count => they react on user click 
      
  is_cor= (document.getElementById("is_cor").value === "0") ? false: true;    // correct must exist or not
                     
  is_back= (document.getElementById("is_back").checked) ? true: false;   // enable Go back (previous item)      
  
  is_forward= (document.getElementById("is_forward").checked) ? true: false; // enable skip item
 
  is_border= (document.getElementById("is_border").checked) ? true: false;  // draw border around chf 0..8 => top big image  (3x3)
 
  demo= (document.getElementById("demo").checked) ? true: false; // demo mode = true => show correct solution
                           
  if (document.getElementById("timer").validity.valid) timer= Math.round(parseInt(document.getElementById("timer").value, 10));  // timer time (s)
 
  timer_enabled= (document.getElementById("timer_enabled").checked) ? true: false;  // timer is enabled or disabled
                       
  prg_type= document.getElementById("prg_type").value;   //  type of information displayed on Progress Bar      
      
  store= (document.getElementById("store_group").disabled === false && document.getElementById("store").value === "1") ? true : false;  
}


// init internal application arrays and parameters
function setPar()  
{             
  stim_b = [];  // bounds for choices
  stim = [];    //  jagged array. within each item is separate array with path polar coordinates 
  cor = [];     // correct solution for each item
  ans = [];     // user answer for each item (dependent var)
  esc = [];     // escape shape
  for (var j= 0; j<item_cnt; j++)    {
    ans[j]= 0;    // set all answers with default: no answer == 0 (missing)
  }  
}


// main stimulus generator 
function stimGenerator()  
{ 
  setPar();
    
  if (window.innerWidth >= window.innerHeight)  {
    horizontalBounds();
  }
  else  {
    verticalBounds();
  }
   
  setRadius();
 
  for (var i=0; i<item_cnt; i++)  {                                                            
    cor[i]= is_cor ? getRndInt(1,chv-1) : getRndInt(0,chv-1);     // choose correct solution, pick one of options stimulus within item (or none)             
  } 
  if (parad === "0")  { 
    for (var i=0; i<item_cnt; i++)  {                                                            
      esc[i]= getRndInt(0,7); //  0..chf-2  (see patt array) => getRndInt(0,chf-2);   
    }
  }
  else  {    
    for (var i=0; i<item_cnt; i++)  {                                                             
      esc[i]= getRndInt(0,11);  // (see patt2 array) =>  index: (12, 13,14) are consising of only one shape + last index 15 is not used
    }
  }     
  var ang= [], a=30;   //angle increment in degrees
  while (a < 360)   {           
    ang.push(a * Math.PI/180);    // window.ang array is in radians for polar coordinates                
    a+= 30;                                               
  }  
  var max= ang.length-1;      
  for (var i=0; i<item_cnt; i++)       
  {                // i = ordinal item count [0..item_cnt-1]
    stim[i]= [];   // create new jagged array instance (for choices path)
    var first= splitCircle(5);            
    stim[i][0]= first;
    var sel={};    // selected angles for path rotation    
    for (var m=1; m<chf; m++)  
    {  // rotate path for fixed choices 1..chf-1 within item        
      do
        var rnd= getRndInt(0,max); 
      while (typeof sel[rnd] !== "undefined");  // each rotation angle can be selected only once within each item         
      sel[rnd]=1;
      stim[i][m]= doRotate(first, ang[rnd]);                               
    }
    for (var m=1; m<=chv; m++)  {  // variable options are not rotated = equal to first chf
      stim[i].push(first);
    }                                                         
  }        
            
}


   
// n == number of sectors (circle parts)
function splitCircle(n) 
{        
  var arr= [];    // return value => stim-coord for this choice       
  // compute choice center (x0, y0)
  var x0= stim_b[0][0] + w2;       // stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch 
  var y0= stim_b[0][1] + w2;          
  var path= setAng(n+1);
  var k= 0;   // k = ordinal number of circle part (shape parts start from number: 0)   
  for (var i=0; i<path.length-1; i++) 
  {    
    var tmp= splitSector(path[i], path[i+1], k);
    for (var j in tmp) {
      arr.push(tmp[j]);   
    }
    k+=3;                 
  }    
  return arr;                  
}


/* split circle sector into n parts
   sAngle = start angle in radians; eAngle = start angle in radians
   k = ordinal number of circle part (0-based)  */
function splitSector(sAngle, eAngle, k)
{ 
  var res=[]; // function output (result)
  var x0= stim_b[0][0] + w2;       //  stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..ch 
  var y0= stim_b[0][1] + w2;        
  var half= (Math.abs(eAngle-sAngle))/2;
   
  /*
  each stim[item][c][j] have jagged array elements: [shape, operation, variable elements]
  // 0. index is always shape number (1-based)
  // 1. index is always operation: see bellow 
  arr instance depends on operation:  
  if (oper == 0) => polygon() arr =  [shape, operation, col, rad1, angle1, rad2, angle2,... radN, angleN ]    // polygon
  if (oper == 1) => sector()  arr = [shape(0), operation(1), sAngle(2), eAngle(3), r_inner(4), r_outer(5), color(6)]);    
  if (oper == 2) => segment() arr= [shape(0), operation(1), sAngle(2), eAngle(3), radius(4), color(5) ]        
  if (oper == 3) => oneArc() arr = [shape, operation, start Angle, end Angle, radius ponder, "color", radius1,angle1, radius2,angle2,.., radiusN,angleN ]);    // arc + lines
  */   
  
  var rnd= getRndInt(1,6);
  
  if (rnd === 1)  
  {    
    res.push([k, 1, sAngle, eAngle, 0, 1, clr[k]]);     
    k++;
    res.push([k, 1, sAngle, sAngle+half, 1, 2, clr[k]]);     
    k++;        
    res.push([k, 1, sAngle+half, eAngle, 1, 2, clr[k]]);            
    //k++;                         
  }
  else if (rnd === 2) 
  {                              
    res.push([k, 0, clr[k],  0,0,  2*Math.cos(half), (sAngle+eAngle)/2, 2,sAngle ]);             
    k++;
    res.push([k, 0, clr[k], 0,0, 2*Math.cos(half), (sAngle+eAngle)/2, 2,eAngle ]);      
    k++;
    res.push([k, 2, sAngle, eAngle, 2, clr[k]]);   
    //k++;            
  }
  else if (rnd === 3) 
  {  
    res.push([k, 0, clr[k], 0,0, 1,sAngle,  1,eAngle ]);  
    k++;
    res.push([k, 0, clr[k], 1,sAngle, 2,sAngle, 2,eAngle, 1,eAngle]);   
    k++;
    res.push([k, 2, sAngle, eAngle, 2, clr[k]]);          
    //k++;                       
  }
  else if (rnd === 4)
  {   
    res.push([k, 0, clr[k], 0,0, 1,sAngle,  2,eAngle ]);   
    k++;
    res.push([k, 0, clr[k], 1,sAngle, 2,eAngle, 2,sAngle /*, 1,sAngle */ ]);   
    k++;
    res.push([k, 2, sAngle, eAngle, 2, clr[k]]);          
    //k++;
  }
  else if (rnd === 5) 
  {   
    res.push([k, 0, clr[k], 0,0, 1,sAngle,  1,eAngle ]);   // inner triangle
    k++;
    res.push([k, 3, sAngle, sAngle+half, 2, clr[k], 1*Math.cos(half),sAngle+half,  1,sAngle /*, 2,sAngle*/ ]);    
    k++; 
    res.push([k, 3, sAngle+half, eAngle, 2, clr[k], 1,eAngle, 1*Math.cos(half),sAngle+half  /*, 2,sAngle+half*/ ]);     
    //k++;         
  } 
  
  else // if (rnd === 6)    
  {   
    var a= (Math.abs(eAngle-sAngle))/3;
    //res.push([k, 3, sAngle, eAngle, radius, "color",      rad1,angle1, rad2,angle2,.., radN,angleN ]);        
    res.push([k, 3, sAngle, sAngle+a, 2, clr[k],       1,sAngle+half,  0, 0,  /*2,sAngle*/ ]);   
    k++;
    res.push([k, 3, sAngle+a, sAngle+2*a, 2, clr[k],   1,sAngle+half, /*2,sAngle+a*/ ]);   
    k++; 
    res.push([k, 3, sAngle+2*a, eAngle, 2, clr[k],     0, 0,  1,sAngle+half, /*2, sAngle+2*a*/ ]);     
    //k++;         
  }                                          
  return res;
}


/* pick array of psudorandom angles. split full circle into n psudorandom sectors
   n => number of  angles (n > 0 integer) */
function setAng(n)
{      
  do
  {
    var res=[], sel={}, a;
    res[0]= 0;    // first angle = 0   
    res[1]= 360;  // last angle = 2*Math.PI => range is always full circle
    for (var j=1; j<= n-2; j++)  
    {                                                                     
      do  
        a= 30 * getRndInt(1,11);  // range 30° .. 330°
      while (typeof sel[a] !== "undefined");    // condition: each angle can be selected only once         
      sel[a]=1;  
      res.push(a);   // collect angle                                             
    }
  } while (!okAngles(res));                   
  res.sort(compareNumbers);   // sort array elements in ascending order numerically    
  for (var j in res)  {
    res[j]= res[j] * Math.PI/180;    // convert degrees to radians
  } 
  return res;
}   


/* sel= all already selected angles; a= tested angle
   return true if this a angle was not already collected and abs difference between ANY collected angle and a angle is < Math.PI */
function okAngles(sel)  {
  sel.sort(compareNumbers); 
  for (var i=0; i<sel.length-1; i++)  {    
    if (Math.abs(sel[i] - sel[i+1]) >= 180) return false;     
  }  
  return true; 
}
   

// numeric sort (sorts array elements in ascending order numerically) 
function compareNumbers(a, b) {
  return a - b;
}


/* ar == first option path within item (all other options are rotated first option)
   angle == rotation angle (radians)  */
function doRotate(ar,angle) 
{ 
  if (rotate === "0" ) {
    return ar;  
  }  
  var res= [];  // copy array (MUST BE)
  for (var i in ar) 
  {  
    res[i]= [];  // new jagged array instance
    for (var j in ar)  {
      res[i][j]=  ar[i][j];           
    }    
  }  
  for (var i in ar) 
  {     
    var oper= res[i][1];
    switch (oper)
    {
      case 0:       
        var j=4, max= res[i].length;   // arr =  [shape, operation, col, rad1, angle1, rad2, angle2,... radN, angleN ]    // polygon
        do  {
          res[i][j]= res[i][j] + angle;  // angle1 .. angleN
          j+=2;
        }
        while (j < max);
        break;
      case 1:
      case 2:
        res[i][2]=  res[i][2] + angle;  // [2] == sAngle
        res[i][3]=  res[i][3] + angle;  // [3] == eAngle
        break;
      case 3:
        // res.push([k, 3, sAngle, eAngle, 2, "green", rad1,angle1, rad2,angle2,.., radN,angleN ]);    // arc + lines
        res[i][2]=  res[i][2] + angle;  // [2] == sAngle
        res[i][3]=  res[i][3] + angle;  // [3] == eAngle
        var j=7, max= res[i].length;   // arr =  [shape, operation, col, rad1, angle1, rad2, angle2,... radN, angleN ]    // polygon
        do  {
          res[i][j]= res[i][j] + angle;  // angle1 .. angleN
          j+=2;
        }
        while (j < max);
        break;   
    } 
  }
  return res;
}


// compute maximum option width (width=height)
function maxw()
{   
  var c_w= window.innerWidth;       // canvas.width
  var c_h= window.innerHeight - 50;  // canvas.height          
  var p= 0.95;   //  => full row/column space is 1. in this case 95% of canvas.width (height) is reserved for all option in on row        
  var w= Math.floor(p * c_w / 3) + 1;  // start with maximum width (x-axis);
  do
  {      
    w-=1;     // izracunaj koliko bi redaka trebalo da se sve opcije (chf + chv) nacrtaju sa ovom sirinom opcije
    var a1 = Math.floor( p * c_w / w ); // ovoliko ih stane u prvi (jedan) red
    var row_cnt= Math.ceil( chv / a1) +3;  // ovoliko redaka treba se se nacrtaju sve chv opcije
    var rest= ( p * c_h - (row_cnt*w) );   // blank space (rest)       
  } while (rest <= 0); 
  return w;    
}


/*   set canvas (viewport) choices (options) bounds if window.innerWidth >= window.innerHeight     
   stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..[chf+chv-1] 
   number of responsive choice within each row is variable (resolution dependent) */                                                                               
function horizontalBounds()  
{ 
  var w_row=3;
  document.getElementById("footer").style.display="block";  // here or in startTask()
  document.getElementById("footer").height= "50";  // const. see img: backward.png => height and forward.png.height  
  var canvas= document.getElementById("canvas");     
  canvas.left= 0;
  canvas.top= 0;
  canvas.width= window.innerWidth;       // stretch canvas to parent
  canvas.height= window.innerHeight - document.getElementById("footer").height;      
  // p => (total viewport space reserved for all options in one row/column ) / 100;       
  var p= 0.95;   //  => full row/column space is 1. in this case 95% of canvas.width (height) is reserved for all option in on row   
  // compute all stimulus width (width=height)
  var total= chf + chv;  // total choices count (non-responsive 0..8 + responsive 9..N)
  
  var w= maxw();  // this is stimulus width (width=height) for all choices   
  var a1 = Math.floor( p * canvas.width / w ); // ovoliko ih maximalno stane u prvi (svaki) red
  var row_cnt= Math.ceil( chv / a1) + 3;  // ovoliko redaka treba se se nacrtaju sve "prave" opcije
  
  // compute horizontal and vertical edges (for centering horizontally and vertical)
  var ex=  ( canvas.width - (a1*w) ) / (a1+1);     // horizontal space delimitator (space within option in same row)   
  var ey= ( canvas.height - (row_cnt*w) ) / (row_cnt+1);   // vertical space delimitator (space between rows)                 
  // set non-responsive choices position on screen (centered horizontally and vertical)  
  var x, y= ey; 
  for (var j=0; j<9; j++)
  {         
  /* 0 1 2
     3 4 5
     6 7 8 */
    if ( j === 3 || j === 6 )  {
       y+= w;
    }
    if (j === 0 || j === 3 || j === 6) {
      x= canvas.width/2 - 1.5 * w;
      x-= 1;    // 2px x-offset
    }
    else if (j === 1 || j === 4 || j === 7) {
      x= canvas.width/2 - 0.5 * w;
      x+= 1; 
    }
    else if (j === 2 || j === 5 || j === 8) {
      x= canvas.width/2 + 0.5 * w;
      x+= 3; 
    }                                                                                              
    stim_b[j]= [x, y, Math.round(x+w),  Math.round(y+w)];   // 0 = left; [1] = top; [2] = right; [3]= bottom           
  }
  if (chv < a1)  {
    ex= ( canvas.width - (chv*w) ) / (chv+1);
  }
  if (row_cnt > 4 && Math.ceil(chv/(row_cnt -3)) < a1)  { // smanji maximalni broj elemenata u jednom retku
    a1 = Math.ceil(chv/(row_cnt -3));   // ukupan broj podijeli na broj persotalih redaka (u prvom retku je uvijek jedan vise)
    ex= ( canvas.width - (a1*w) ) / (a1+1);     // update horizontal space delimitator (space within option in same row)   
  }
  x=ex;
  y+= w + 3*ey;
  var i=1, row=4;       
  for (var j=9; j<total; j++)  
  {                       
    var new_row= (i > a1) ? true : false; 
    if (new_row) {                 
      x= ex; 
      y+= w + ey;
      row++; 
      i=1;
    } 
        
    stim_b[j]= [x, y, Math.round(x+w),  Math.round(y+w)];   // 0 = left; [1] = top; [2] = right; [3]= bottom           
    x+= w + ex;
    i++;                           
  }                             
}


/* set canvas (viewport) choices (options) bounds if window.innerWidth < window.innerHeight     
   stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0..[chf+chv-1] 
   number of responsive choice within each row is ALWAYS fixed == 3 */               
function verticalBounds()  
{ 
  var w_row=3;
  document.getElementById("footer").style.display="block";  // here or in startTask()
  document.getElementById("footer").height= "50";  // const. see img: backward.png => height and forward.png.height  
  var canvas= document.getElementById("canvas");     
  canvas.left= 0, canvas.top= 0;
  canvas.width= window.innerWidth;       // stretch canvas to parent
  canvas.height= window.innerHeight - document.getElementById("footer").height;      
  // p => (total viewport space reserved for all options in one row/column ) / 100;       
  var p= 0.95;   //  => full row/column space is 1. in this case 95% of canvas.width (height) is reserved for all option in on row   
  // compute all stimulus width (width=height)
  var total= chf + chv;  // total choices count (non-responsive 0..8 + responsive 9..N)
  var row_cnt = Math.ceil(total/w_row);  // options total row count   
  var wx= p * canvas.width / w_row;
  var wy= p * canvas.height / row_cnt;     // row count on screen   
  var w= Math.floor(Math.min(wx, wy));  // this is stimulus width (width=height) for all choices   
  // compute horizontal and vertical edges (for centering horizontally and vertical)
  var ex=  ( canvas.width - (w_row*w) ) / (w_row+1);     // horizontal space delimitator (space within option in same row)   
  var ey= ( canvas.height - (row_cnt*w) ) / (row_cnt+1);   // vertical space delimitator (space between rows)                 
  // finally set choices position on screen (centered horizontally and vertical)  
  // non-responsive choices
  var x, y= ey; 
  for (var j=0; j<9; j++)
  {         
  /* 0 1 2
     3 4 5
     6 7 8 */
    if ( j === 3 || j === 6 )  {
       y+= w;
    }
    if (j === 0 || j === 3 || j === 6) {
      x= canvas.width/2 - 1.5 * w;
      x-= 1;    // 2px x-offset
    }
    else if (j === 1 || j === 4 || j === 7) {
      x= canvas.width/2 - 0.5 * w;
      x+= 1; 
    }
    else if (j === 2 || j === 5 || j === 8) {
      x= canvas.width/2 + 0.5 * w;
      x+= 3; 
    }                                                                                              
    stim_b[j]= [x, y, Math.round(x+w),  Math.round(y+w)];   // 0 = left; [1] = top; [2] = right; [3]= bottom           
  }    
  // responsive choices    
  if (chv === 2)  {   
    ex= (canvas.width - 2*w) / 3;   // update horizontal space delimitator if only 2 responsive options        
  }    
  y+= 2*ey;  //x=ex; 
  for (var j=9; j<total; j++)  
  {                           
    var n_row= (j % w_row === 0) ? true : false;  // new row or not. in first iteration is always true (9/3==0)
    if (n_row) {                 
      x= ex; 
      y+= w + ey;
    }                                                                                             
    stim_b[j]= [x, y, Math.round(x+w),  Math.round(y+w)];   // 0 = left; [1] = top; [2] = right; [3]= bottom               
    x+= w + ex;                            
  }                              
}


// set window.w2 = half of option width/height (width==height)
// set window.r shape radius => 1/2 of w2  == 1/4*option width ==1/4*option height
function setRadius()  
{ 
  // stim_b[0] ==>  0 = left; [1] = top; [2] = right; [3]= bottom   
  var width= (stim_b[0][2] - stim_b[0][0])/2; 
  var height= (stim_b[0][3] - stim_b[0][1])/2;
  //set window.w2 = half of option width or height = (right - left)/2 = (bottom - top)/2 = const 
  w2= Math.min(width,height);   
  // set window.r shape radius => 1/2 of w2 = 1/4*option width = 1/4*option height
  r= Math.floor(w2/2);   // - 2; => -2 => padding from border     
  if (r < 5) alert("Your screen resolution is probably not enough to distinguish the drawings that will be displayed.\nPossible solution:\n  -reduce the Number of choices. The number of choices is = " + chv );  
}


// get random integer from min to max range
function getRndInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


// application timer handler function
function wm9Timer()  {  
  if (!is_task) return;  // nop, idle  
  var cur= (Date.now() - startTime)/clock;
  if (timer_enabled && cur >= timer )  {     // Task time is limited
    theEnd();
  }   
  if (prg_type === "0" )  
  {  //  "0" => Items. display item count on Progress Bar (default)                                                                                                                                                        
    var percent = 100*(item_cnt-(item+1))/item_cnt;  // Math.round();      
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= "Item= " + (item + 1) + " Remaining= " + (item_cnt - item-1);  
  }    
  else if (timer_enabled && prg_type === "1")  
  {   // "1" => Time. display time on Progress Bar  
    var rest=timer-cur;   // this is remaining time 
    var percent= Math.round(100*rest/timer);    
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= stringTime(rest);    
  } 
} 


// return integer into string hh:mm:ss time format
// input par: total == integer (time in seconds)
function stringTime(total) {
  var hh = Math.floor(total/(60*60));         
  var divisor_for_minutes = total % (60 * 60);
  var mm = Math.floor(divisor_for_minutes / 60);       
  var divisor_for_seconds = divisor_for_minutes % 60;
  var ss = Math.ceil(divisor_for_seconds);    
  // These lines ensure you always have two-digits. This formats your string to HH:MM:SS
  if (hh < 10)  {hh = "0"+hh;}     
  if (mm < 10) {mm = "0"+mm;}
  if (ss < 10) {ss = "0"+ss;} 
  return hh + ":" + mm + ":" + ss;
} 


// goto previous item (stimulus)
function priorAnswer()  {                         
  if (item > 0) {
    item--;  
    drawStim();     // draw again previous stimulus
  }         
}


// goto next item (stimulus)
function nextItem()  {               
  if (item < item_cnt-1)  {         
    item++; 
    drawStim();     // draw next stimulus        
  }
  else  {               
    theEnd();  // end of task  
  }
}


// draw (repaint) stimulus    
function drawStim() 
{     
  var canvas= document.getElementById('canvas');
  var ctx = document.getElementById('canvas').getContext('2d'); 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas              
  var sel={}, add1= 0, is_add= false; 
  
  for (var j in stim_b) 
  { // j= choices within item               
    var off = j-8;  // offset for responsive chv choices (they started at index 9..)  
    // draw border around each choices bounds
    
    if (j == 0 && is_border)
    {  // fixed choices => chf (3x3 big image)
      var t= 1; // offset from edge
      ctx.beginPath(); 
      ctx.strokeStyle= "#000000";
      ctx.rect(stim_b[0][0]-t,  stim_b[0][1]-t, stim_b[8][2] - stim_b[0][0]+2*t,  stim_b[8][3] - stim_b[0][1]+2*t);               
      ctx.stroke();  // draw border around fixed options (chf) => 0..8      
    }    
    else if (j > 8)
    {
      ctx.beginPath(); 
      ctx.strokeStyle= "#000000";
      /* [0] = left; [1] = top; [2] = right; [3]= bottom
          choice_width=  stim_b[j][2] - stim_b[j][0];  // right - left
          choice_height= stim_b[j][3] - stim_b[j][1]; // bottom - top    */  
      ctx.rect(stim_b[j][0],  stim_b[j][1], stim_b[j][2] - stim_b[j][0] ,  stim_b[j][3] - stim_b[j][1]);   // draw border around each choices bounds 
      if ( (ans[item] == off) || (demo && cor[item] == off) )  
      { // set background color for selected answer or set background color in demo mode for correct answer. you must call before drawShape() handler               
        // Gray90 == selected or Ivory == correct 
        ctx.fillStyle = (ans[item] == j - 8)  ?   "#E5E5E5" : "#FFFFF0";  // the selected answer takes precedence over the correct answer (background color)                   
      }
      else  {
        ctx.fillStyle = "#FFFFFF";    // white
      }  
      ctx.fill();   
      ctx.stroke();    // draw border around each choices bounds
    }
                                  
    var x= stim_b[j][0] + w2 ;     //  stim_b[j][0] + r;    stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    j= 0 .. chf+chv-1 
    var y= stim_b[j][1] + w2 ;      
    
    circle(ctx, x, y, 2*r, 0, 2*Math.PI, false, "#000000");  // full outer circle => border for chf
        
    if (parad === "0" && j == esc[item])  {
      //ctx.font= w2 + "px Calibri";   // the height of the text in pixels is equal to the font size in pts when the font is defined with the font property of the canvas context
      ctx.font = w2 + "px Arial";         // begin of draw point number within each Circle
      ctx.textAlign = "center";
      ctx.fillStyle = "black";      
      ctx.fillText('?', x, y+r/2);  // ctx.fillText('?', x, y); 
      continue;
    }  
                    
    // parad="0" selected =>Rule row-column.  parad="1" => Missing part 
    if ( j < 9 )  {
      if (parad === "0")  {
        dispatch0(ctx, j, j);  // non-responsive option chf => paradigm "0"
      }
      else  {
        dispatch1(ctx, j, j);  // non-responsive option chf => paradigm "1"
      }
    }
    
    else   // responsive choices chv
    {
      if (parad === "0")
      {   
        var eq= {}; 
        
        if (cor[item] > 0 && cor[item] == off)   {       
          dispatch0(ctx, esc[item], j);   // responsive option chv => correct choice
        }                
        else // if (cor[item] != off)  
        { //  responsive option chv => incorrect choice           
          var index= esc[item], e= patt[index], up=e.length, eq_cnt= 0;           
          for (var shape=0; shape<up; shape++)  { 
            if (patt[index][shape] === "1") {
              eq_cnt++;
              eq[shape]=shape;   // this shape belongs to correct choice  
            }  
          } 
          var full= eq_cnt;    // range: 3..8      
          eq_cnt--;  // eq_cnt => number of equal shapes in correct and incorrect choices                   
          var cnt= 0, s="";
          for (var shape=0; shape<up; shape++)  
          { 
            if ( patt[index][shape] === "1"  )  s+=shape + " "; 
            if ( patt[index][shape] === "1" && cnt < eq_cnt )  {
              drawShapes(ctx, item, j, shape);     // these shapes are same for all incorrect choices and correct choice
              cnt++;
            }   
          }           
          // draw last shape(s). they must be different from last shape in correct choice 
          if (add1 < 15-full)       
          { 
            do            
              var rnd= getRndInt(0,smax);  // full range: 0..14
            while (typeof sel[rnd] !== "undefined" || typeof eq[rnd] !== "undefined");  
            sel[rnd]=1;                   
            drawShapes(ctx, item, j, rnd);
            add1++; 
          }
          else  
          { 
            if (!is_add) 
            {  
              is_add= true;  // do nothing ONLY ONE choice will have one shape LESS then correct choice
              continue;
            }
            else  
            {
              for (var i=1; i<=5; i++)  
              {  // 5 more shapes (this shapes are not belong to correct choice). same shape can be selected twice or more time 
                do            
                  var rnd= getRndInt(0,smax);  // full range: 0..14
                while (typeof eq[rnd] !== "undefined");  // only condition: this shapes are not belong to correct choice 
                drawShapes(ctx, item, j, rnd);
              }                 
            }          
          } 
        } // else if (cor[item] != off)          
                 
      }  // if (parad === "0")
      
      else if (parad === "1")      
      {      
        if (cor[item] > 0 && cor[item] == off)   {                 
          drawShapes(ctx, item, j, esc[item]);   // responsive option chv => correct choice 
        }      
        else //if (cor[item] != off)  
        {   //  responsive option chv => incorrect choice
          do
            var rnd= getRndInt(0,smax);    // full range 0..14
          while (rnd == esc[item] || typeof sel[rnd] !== "undefined");  // this shape is not belong to correct choice and not already selected 
          sel[rnd]=1;        
          drawShapes(ctx, item, j, rnd);  
          // why add more shapes? same shapes are same. choose closest (neighbor) 
          // add one more without condition can be same like correct shape => esc[item] or already selected
          rnd = ( rnd === smax ) ? (rnd - 1) : (rnd+1);  
          drawShapes(ctx, item, j, rnd);                          
        }                
      }
      
     }  // responsive choices chv
                                         
  }   //  for (var j in stim_b)
              
  // set footer navigation buttons
  if (is_cor === false  || is_forward)       //item < item_cnt
  {  
    var btn=document.getElementById("next");     
    btn.style.backgroundImage = (item === item_cnt-1)  ?  "url('img/end.png')" : "url('img/forward.png')"; 
    btn.style.display= "inline";  
  }
  else {
    document.getElementById("next").style.display= "none";
  }
  if (item > 0 && is_back)  {  
    document.getElementById("prior").style.display= "inline"; 
  }
  else  {
    document.getElementById("prior").style.display= "none";   
  }    
  if   (prg_type === "0" )  
  {  // display (update) item count on Progress Bar (default)                                                                                                                                                         
    var percent = 100*(item_cnt-(item+1))/item_cnt;  // Math.round();      
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= "Item= " + (item + 1) + " Remaining= " + (item_cnt - item-1);  
  }
}


// paradigm == "0" => calling drawShapes() for selected shapes (defined in patt array)
// index == cell patt index always 0..8
// choice == option number to draw (responsive choices chv or non-responsive choices chf)  
function dispatch0(ctx, index, choice)
{  
  index= parseInt(index, 10); 
  var e= patt[index], up=e.length;
  for (var shape=0; shape<up; shape++)  { 
    if (patt[index][shape] === "0") continue; 
    drawShapes(ctx, item, choice, shape); 
  }       
}


// paradigm == "1" => calling drawShapes() for selected shapes (defined in patt2 array)
// index == cell patt2 index always 0..8
// choice == option number to draw (responsive choices chv or non-responsive choices chf) 
function dispatch1(ctx, index, choice)
{  
  index= parseInt(index, 10); 
  var e= patt2[index], up=e.length;
  for (var shape=0; shape<up; shape++)  { 
    if ( patt2[index][shape] === "0" || shape == esc[item] ) continue; 
    drawShapes(ctx, item, choice, shape);
  }        
}

 
/* ctx = canvas context;  item = item number; c = choice number (0-based); 
   s = shape number to draw 0-based (null = draw all shapes) */
function drawShapes(ctx, item, c, s)
{     
  var x0=  stim_b[c][0] + w2;    // stim_b[c][0] + r;     
  var y0= stim_b[c][1] + w2;     // stim_b[c][1] + r;  
  // stim[item][c][j] => [shape, operation, .. variable by operation]      
  for (var j in stim[item][c])  
  {            
    if (s != null && s != stim[item][c][j][0]) continue;   // escape this shape    
    var oper= stim[item][c][j][1];   

    if (oper == 0) {      
      polygon(ctx, c, stim[item][c][j]);        
    } 
    else if (oper == 1)  {   
    // res.push([shape(0), operation(1), sAngle(2), eAngle(3), r_inner(4), r_outer(5), color(6)]);    
    // sector(ctx, x0, y0, r_inner, r_outer, sAngle, eAngle, col)  
      sector(ctx, x0, y0, r * stim[item][c][j][4] ,  r * stim[item][c][j][5], 
             stim[item][c][j][2] , stim[item][c][j][3], stim[item][c][j][6]);    
    }
    else if (oper == 2)  {      
      //res.push([shape, operation, sAngle, eAngle, radius, color]);    // segment       
      segment(ctx, x0, y0, r * stim[item][c][j][4], stim[item][c][j][2], stim[item][c][j][3], stim[item][c][j][5]);                      
    } 
    else if (oper == 3) {     
      oneArc(ctx, c, stim[item][c][j]);        
    }            
  }                     
}  


/* draw full circle:  col ==  color;
  for other parameters see: https://www.w3schools.com/tags/canvas_arc.asp   */       
function circle(ctx, x, y, r, sAngle, eAngle, clock, col)
{
  ctx.beginPath(); 
  ctx.arc(x, y, r, sAngle, eAngle, clock);  //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);            
  ctx.strokeStyle= col;    
  ctx.stroke();
}


// draw polygon with input polar coordinates. see function splitSector()  oper == 0
// arr =  [shape, operation, col, rad1, angle1, rad2, angle2,... radN, angleN ]    // polygon
function polygon(ctx, c, arr)
{     
  ctx.strokeStyle= demo ? arr[2] : "#000000";   // if (demo === false ) => black color
  ctx.fillStyle= demo ? arr[2] : "#000000"; 
  var x0= stim_b[c][0] + w2;    //  stim_b[c][0] + r;   stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom   
  var y0= stim_b[c][1] + w2;     // stim_b[c][1] + r;  
  ctx.beginPath(); 
  var x = x0 + r * arr[3] * Math.cos(arr[4]);    
  var y = y0 + r * arr[3] * Math.sin(arr[4]);
  ctx.moveTo(x,y);
  for (var j=5; j<arr.length; j=j+2) {
   x = x0 + r * arr[j] * Math.cos(arr[j+1]);    
   y = y0 + r * arr[j] * Math.sin(arr[j+1]);   
   ctx.lineTo(x,y);
  }
  ctx.closePath();
  ctx.fill();    
  ctx.stroke(); 
}

 
/* draw circle SECTOR  see function splitSector()  oper == 1
 ctx = canvas context, x0, y0 = x, y circle center, r_inner= inner circle radius, r_outer = outer circle radius, 
 sAngle= start angle (radians), eAngle = end angle (radians); col = color */
function sector(ctx, x0, y0, r_inner, r_outer, sAngle, eAngle, col)
{     
  ctx.strokeStyle= demo ? col : "#000000";  // if (demo === false ) => black color
  ctx.fillStyle= demo ? col : "#000000";        
  // 1. half    
  ctx.beginPath();
  var x = x0 + Math.round(r_inner * Math.cos(sAngle)); 
  var y=  y0 + Math.round(r_inner * Math.sin(sAngle));
  ctx.moveTo(x,y); 
  x = x0 + Math.round(r_outer * Math.cos(sAngle)); 
  y=  y0 + Math.round(r_outer * Math.sin(sAngle));
  ctx.lineTo(x,y);     
  ctx.arc(x0, y0, r_outer, sAngle, eAngle, false);  //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);        
  ctx.closePath();
  ctx.stroke();   
  ctx.fill();  
  // 2. half
  ctx.beginPath();
  x = x0 + Math.round(r_outer * Math.cos(eAngle)); 
  y=  y0 + Math.round(r_outer * Math.sin(eAngle));
  ctx.moveTo(x,y); 
  x = x0 + Math.round(r_inner * Math.cos(sAngle)); 
  y=  y0 + Math.round(r_inner * Math.sin(sAngle));
  ctx.lineTo(x,y);     
  ctx.arc(x0, y0, r_inner, sAngle, eAngle, false);  //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);        
  ctx.closePath();
  ctx.stroke();   
  ctx.fill();      
}


/* draw circle segment.  see function splitSector()  oper == 2
 ctx = canvas context, x0 = x circle center, y0 = y circle center, rad = circle radius, 
 sAngle= start angle (radians), eAngle = end angle (radians); col = color */
function segment(ctx, x0, y0, rad, sAngle, eAngle, col)
{       
  ctx.strokeStyle= demo ? col : "#000000";   // if (demo === false ) => black color
  ctx.fillStyle= demo ? col : "#000000";    
  ctx.beginPath();
  var x = x0 + Math.round(rad * Math.cos(sAngle)); 
  var y=  y0 + Math.round(rad * Math.sin(sAngle));
  ctx.moveTo(x,y);  
  ctx.arc(x0, y0, rad, sAngle, eAngle, false);    //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);        
  ctx.closePath();
  ctx.stroke();   
  ctx.fill();
}


// draw circle segment with one arc + N lines => see function splitSector()  oper == 3
//           0  1    2       3     4    5       6,    7      8,   9
// res.push([k, 3, sAngle, eAngle, 2, "green", rad1,angle1, rad2,angle2,.., radN,angleN ]);    // arc + lines
function oneArc(ctx, c, arr)
{
  var x0= stim_b[c][0] + w2;     
  var y0= stim_b[c][1] + w2;  
  ctx.strokeStyle= demo ? arr[5] : "#000000";     // if (demo === false ) => black color
  ctx.fillStyle=   demo ? arr[5] : "#000000";
  ctx.beginPath(); 
  ctx.arc(x0, y0, r*arr[4], arr[2], arr[3], false);   // ctx.arc(x0, y0, radius, sAngle, eAngle, false);  
  //var x = x0 + r * arr[3] * Math.cos(arr[4]);    
  //var y = y0 + r * arr[3] * Math.sin(arr[4]);
  //ctx.moveTo(x,y);
  var x, y;
  for (var j=6; j<arr.length; j=j+2) {
    if (typeof arr[j+1] === "undefined") break;
    x = x0 + r * arr[j] * Math.cos(arr[j+1]);    
    y = y0 + r * arr[j] * Math.sin(arr[j+1]);   
    ctx.lineTo(x,y);
  }
  ctx.closePath(); 
  ctx.stroke();
  ctx.fill();
}


// user selected answer (drawings) with mouse
//<canvas id="canvas" onclick="doAnswer(event)"></canvas>   
function doAnswer(e)  
{        
  var x= e.clientX, y= e.clientY;
  var tot= chf+chv;
  for (var j= chf; j<tot; j++)      
  { // stim_b[j]=>  [0] = left; [1] = top; [2] = right; [3]= bottom    
    if ( x > stim_b[j][0] && x < stim_b[j][2] &&  y > stim_b[j][1] && y < stim_b[j][3])  
    {                            
      var k= j - chf + 1; 
      ans[item]= ans[item] === k ? 0 : k;      // toggle (reset) answer if user choose already selected answer      
      drawStim(); // repaint => update backgroundColor for (un)selected answers
      if (ans[item] > 0) nextItem();
    }
  } 
}


// end of task (research)
function theEnd()  
{     
  is_task= false;
  document.getElementById("canvas").style.display="none"; // this disable doAnswer() event
  document.getElementById("footer").style.display="none";
  document.getElementById("end").style.display="block";  
  var res=0, err=0, mis=0, s;  
  var total=cor.length; 
  for (var j=0; j!=total; j++)   {
    if (cor[j] === ans[j]) { 
      res++;
    }
    else if (ans[j] === 0)  {
      mis++;
    }
    else  {
      err++;
    }
  }                                                         
  s="Correct= " + res + " (" + (100*res/total).toFixed(2) + "%). Errors= " + err;
  s+= " (" + (100*err/total).toFixed(2) + "%)  Missing= " + mis + " (" + (100*mis/total).toFixed(2) + "%). Total items="  + total; 
  document.getElementById("score").textContent=s;
  document.getElementById("google-wrapper").style.display="block";
  document.getElementById("no_google").textContent="";  
  
  try  {
    drawReport(res,err,mis);  
  }
  catch (e)  {
    document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 
  }
  
  try 
  {
    if (store) {
      createStorage(res,err,mis);  
    }
    else  {
      document.getElementById("table_grp").innerHTML= "";
    }
  }
  catch (e)  { 
    document.getElementById("table_grp").innerHTML= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }
           
}


/* async draw and display tables and charts with user results (call google API)..
 (chart = PIE + table) => Displays the sum of: correct answers, errors, and missing values   
  res = total correct answers in task (sum)
  err = total errors in task (sum)
  mis = total missing values in task (sum)  */
function drawReport(res, err, mis) 
{              
  //    xxx  table = Displays the sum of: correct answers, errors, and missing values  xxx 
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Answer type');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Sum');      // sum(correct answers, errors, missing values) = number = frequencies             
  data.addRow ( ["Correct", res] );
  data.addRow ( ["Errors", err] ); 
  data.addRow ( ["Missing", mis] );                                      
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };           
  var elem= document.getElementById("table");
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
  
  //    xxxxxx      PIE chart  => data are same   xxxxxxx  
  options= {
   title: 'Correct answers, errors and missing values',
   is3D: true,
   width: '100%'   
  }; 
  elem = document.getElementById("chart");   
  elem.style.display = "block"; 
  new google.visualization.PieChart(elem).draw(data, options);     // Create and draw the visualization.     
         
}  
  

// create wm9 window.localStorage
function createStorage(res,err,mis)   
{  
  var oldItems = JSON.parse(localStorage.getItem("wm9-v1.0")) || []; 
  var id= oldItems.length+1;  
 // set new "record"  
  var newItem = {
      'id': id,
      'date': new Date(),      
      'Correct': res, 
      'Errors': err,       
      'Missing': mis,                                            
      'Show-correct' : demo ? "Yes": "No",   
      'Paradigm' : document.getElementById("parad").value,
      'Rotation' : document.getElementById("rotate").value,  
      'items': item_cnt,
      'Choices' : document.getElementById("chv").value,             
      'Correct-exist' : document.getElementById("is_cor").value,                                
      'Timer-time' : (document.getElementById("timer_enabled").checked) ? document.getElementById("timer").value : "",      
      'Is-Back' : (is_back) ? 1: 0, 
      'Is-Forward' : (is_forward) ? 1:0          
  };

  oldItems.push(newItem);

  localStorage.setItem("wm9-v1.0", JSON.stringify(oldItems));

  createTableJSON(document.getElementById("table_grp"), oldItems); 
  
  document.getElementById("score").textContent+= ". (ID=" + id + ")";
 
}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  var col = [];
  for (var i = 0; i < my_json.length; i++) {
    for (var key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  var table = document.createElement("table");
  table.setAttribute("class", "my_table");    // table.className = 'my_table';
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  var tr = table.insertRow(-1);                   // TABLE ROW.
  for (var i = 0; i < col.length; i++) {
      var th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (var i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (var j = 0; j < col.length; j++) {
      var tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


// clear wm9 web browser storage data
function clrStorage()  
{  
  var cnt= localStorage.getItem("wm9-v1.0")  ?  JSON.parse(localStorage.getItem("wm9-v1.0")).length : 0;                                                        
  if (cnt === 0)  {
    alert("You have no wm9 data to delete");
    return;
  }  
  if ( !window.confirm("You have a total of " + cnt  + " wm9 results stored in your web browser. Continue?") ) { 
   return;
 }                                             
 if (window.confirm("Delete total saved wm9 results:  "  + cnt + ". This action cannot be undone. Final confirmation?") ) 
 { 
   window.localStorage.removeItem("wm9-v1.0"); 
   document.getElementById("store_cnt").textContent= "All data has been deleted. No data";
 }  
}
